<template>
	<v-app v-if="auth">
		<div class="d-flex">
			<nuxt-link class="mx-3" :to="{ name: 'home' }">Home</nuxt-link>
			<nuxt-link class="mx-3" :to="{ name: 'pagination' }">Pagination</nuxt-link>
			<nuxt-link class="mx-3" :to="{ name: 'addRow' }">Add Row</nuxt-link>
			<v-btn class="mx-3" small color="primary" @click="logout">Log out</v-btn>
		</div>

		<v-main :style="$route.name == 'home' ? 'background: #F4F4F4;' : 'background: #FFFFFF;'">
			<nuxt />
		</v-main>
	</v-app>
</template>

<script>
import * as easings from 'vuetify/lib/services/goto/easing-patterns';

export default {
	data() {
		return {
			hidden: true,
			scrollTo: 0,
			easing: 'easeInOutCubic',
			easings: Object.keys(easings),
		};
	},

	loading: {
		color: 'green',
		height: '5px',
	},

	beforeMount() {
		window.addEventListener('scroll', this.handleScroll);
	},

	methods: {
		handleScroll() {
			if (window.scrollY >= 80) {
				this.hidden = false;
			} else {
				this.hidden = true;
			}
		},
		async logout() {
			this.$swal
				.fire({
					title: 'Are you sure?',
					text: 'You are about to be logged out!',
					icon: 'warning',
					showCancelButton: true,
					confirmButtonColor: '#3085d6',
					cancelButtonColor: '#d33',
					confirmButtonText: 'Yes, Logged me out!',
				})
				.then(async (result) => {
					if (result.isConfirmed) {
						var swalala = this.$swal.fire({
							title: 'Processing Your Request...',
							icon: 'warning',
							showCloseButton: false,
							showConfirmButton: false,
							showCancelButton: false,
							allowOutsideClick: false,
						});
						// Log out the user.
						await this.$store.dispatch('auth/logout');
						swalala.close();
						this.$swal.fire('Logged Out!', 'Your session has been successfully destroyed.', 'success').then((v) => {
							if (v.isConfirmed) {
								// Redirect to login.
								this.$router.push({ name: 'login' });
							}
						});
					}
				});
		},
	},

	beforeDestroy() {
		window.removeEventListener('scroll', this.handleScroll);
	},

	computed: {
		target() {
			return this.scrollTo;
		},
		options() {
			return {
				duration: 300,
				offset: 0,
				easing: this.easing,
			};
		},
		user() {
			return this.$store.getters['auth/user'];
		},
		auth() {
			return this.$store.getters['auth/check'];
		},
	},
};
</script>
